import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class Kanone extends Objekte
{
    private boolean waitingForBall = false;

    private static final double ANGULAR_SPEED = 0.9; // Winkeleinstellung der Kannone in 1/100 sekunden.
    private static final double MAX_ANGLE = 80; // MAximale auslage des Winkels.

    private double angle = 0; // Derzeitiger Winkel (Erh?hung der Prezision der Kanone)
    private Ball ball = null; // Der Ball geh?rt der Kanone bis er die Map trifft
    private boolean wasUpPressed = false; // Taste zum entlassen des Balles
    private int anzahlSchuesse;
    private PunkteStandAnzeige myScore;

    protected void addedToWorld(World world)
    {
        // Vorbereitung des ersten Balles
        prepareBall();
    }

    
    public Kanone(PunkteStandAnzeige a)
        {
            anzahlSchuesse = 0;
            myScore = a;}
            
    public void act(double deltaTime) 
    {
        // Handle key presses.
        handleKeys(deltaTime);

        // Wenn wir auf einen Ball warten und er gerade stehen bleibt:
        boolean ballFinishedMoving = ball.getState() != Ball.STATE_MOVING;
        if(waitingForBall && ballFinishedMoving)
        {
            // Das Warten wird gestoppt und ein neuer Ball wird geladen
            waitingForBall = false;
            prepareBall();
        }
    }

    public void prepareBall()
    {
        // Hier wird der zur Vorbereitung gebrauchter Ball geladen er wird zuf?lig von den schon liegenden B?llen genommen
        
        int[] allowedBallTypes = ((BubbleWorld)getWorld()).getMap().getAllowedBallTypes();
        
        if (allowedBallTypes.length > 0) {
            int type = allowedBallTypes[Greenfoot.getRandomNumber(allowedBallTypes.length)];
            
            // Er wird erschaffen und in die Welt eingefgt
            ball = new Ball(type);
            getWorld().addObject(ball, getX(), getY());
        }
    }

    private void fireBall()
    {
        // Ton beim Schuss
        Greenfoot.playSound("fire.wav");
        
        // Der Ball wird bewegt und es wird gewartet bis er etwas trifft
        ball.move(angle);
        waitingForBall = true;
        anzahlSchuesse = anzahlSchuesse +1;
        myScore.setText("Schuesse: " +anzahlSchuesse);
    }

    private void handleKeys(double deltaTime)
    {   
        // Wenn man die Pfeiltaste oben drckt wird der Ball geschossen, wenn er bereit ist
        // Das zus?tzliche !wasWPressed ist dazu da das man versichert das die Pfeiltast losgelassen wurde
        boolean isUpPressed = Greenfoot.isKeyDown("up");
        if(isUpPressed && !wasUpPressed && !waitingForBall)
        {
            fireBall();
        }

        // Der Status der "oben" Pfeiltaste wird gespeichert, damit man nicht unendlich mal schiesst
        wasUpPressed = isUpPressed;

        // linke Pfeiltaste= Kanone neigt sich nach links
        if(Greenfoot.isKeyDown("left"))
        {
            angle = Math.max(-MAX_ANGLE, angle - ANGULAR_SPEED * deltaTime);
            setRotation((int)angle);
        }

        // Rechte Pfeiltaste= Kanone neigt sich nach rechts
        if(Greenfoot.isKeyDown("right"))
        {
            angle = Math.min(MAX_ANGLE, angle + ANGULAR_SPEED * deltaTime);
            setRotation((int)angle);
        }
        
        
    }    
}
