import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class Kanone2 extends Objekte
{
    private boolean waitingForBall = false;

    private static final double ANGULAR_SPEED = 0.9; // Winkeleinstellung der Kannone in 1/100 sekunden.
    private static final double MAX_ANGLE = 80; // MAximale auslage des Winkels.

    private double angle = 0; // Derzeitiger Winkel (Erh?hung der Prezision der Kanone)
    private Ball ball = null; // Der Ball geh?rt der Kanone bis er die Map trifft
    private boolean wasWPressed = false; // Taste zum entlassen des Balles

    protected void addedToWorld(World world)
    {
        // Vorbereitung des ersten Balles
        prepareBall();
    }

    public void act(double deltaTime) 
    {
        // Kontrolle der gedrckten Tasten
        handleKeys(deltaTime);

        // Wenn wir auf einen Ball warten und er gerade stehen bleibt:
        boolean ballFinishedMoving = ball.getState() != Ball.STATE_MOVING;
        if(waitingForBall && ballFinishedMoving)
        {
            // Das Warten wird gestoppt und ein neuer Ball wird geladen
            waitingForBall = false;
            prepareBall();
        }
    }

    public void prepareBall()
    {
        // Hier wird der zur Vorbereitung gebrauchter Ball geladen er wird zuf?lig von den schon liegenden B?llen genommen
        
        int[] allowedBallTypes = ((BubbleWorld)getWorld()).getMap().getAllowedBallTypes();
        
        if (allowedBallTypes.length > 0) {
            int type = allowedBallTypes[Greenfoot.getRandomNumber(allowedBallTypes.length)];
            
            // Er wird erschaffen und in die Welt eingefgt
            ball = new Ball(type);
            getWorld().addObject(ball, getX(), getY());
        }
    }

    private void fireBall()
    {
        // Ton beim Schuss
        Greenfoot.playSound("fire.wav");
        
        // Der Ball wird bewegt und es wird gewartet bis er etwas trifft
        ball.move(angle);
        waitingForBall = true;
    }

    private void handleKeys(double deltaTime)
    {   
        // Wenn man die Taste W drckt wird der Ball geschossen, wenn er bereit ist
        // Das zus?tzliche !wasWPressed ist dazu da das man versichert das die Taste losgelassen wurde
        boolean isWPressed = Greenfoot.isKeyDown("w");
        if(isWPressed && !wasWPressed && !waitingForBall)
        {
            fireBall();
        }

        // Der Status der "W" Taste wird gespeichert, damit man nicht unendlich mal schiesst
        wasWPressed = isWPressed;

        // A Taste= Kanone neigt sich nach links
        if(Greenfoot.isKeyDown("a"))
        {
            angle = Math.max(-MAX_ANGLE, angle - ANGULAR_SPEED * deltaTime);
            setRotation((int)angle);
        }

        // D Taste= Kanone neigt sich nach rechts
        if(Greenfoot.isKeyDown("d"))
        {
            angle = Math.min(MAX_ANGLE, angle + ANGULAR_SPEED * deltaTime);
            setRotation((int)angle);
        }
    }    
}
